<?php
class InterLinks_Widget extends WP_Widget {
    function InterLinks_Widget() {  
        $widget_ops = array( 'classname' => 'interlinks_widget', 'description' => 'A widget that displays the Interlinks.' );  
        $control_ops = array( 'width' => 400, 'height' => 450, 'id_base' => 'interlinks_widget-widget' );  
        $this->WP_Widget( 'interlinks_widget-widget', 'InterLinks Widget', $widget_ops, $control_ops );  
    }
	
	function widget( $args, $instance ) {
		extract($instance);
		extract( $args );
		if ( is_home() || is_front_page() ) {
			do_action('home-interlink-page','home');
		} else if ( is_page() ) {
			global $post; 
			$interlink_category = get_post_meta($post->ID, "interlink_category", TRUE);
			if ($interlink_category) {
				do_action('home-interlink-page','page');
				$term = get_term( $interlink_category, 'category' );
				/*
				?>
				<h3>Category</h3>
				<li><a href="<?php echo get_category_link( $interlink_category );?>"><?php echo $term->name;?></a></li>
				<?php
				*/
				do_action('category-recent-posts', $term->term_id);
			}
		} else if ( is_category() ) {
			$cat_id = get_cat_id( single_cat_title( "", FALSE ) );
			$interlink_page = get_option( $cat_id . "_interlink_page" );
			 
			$interlink_category = get_post_meta( $interlink_page, "interlink_category", TRUE );
			if ($interlink_category) {
				do_action('home-interlink-page');
				$term = get_term( $interlink_category, 'category' );
				/*
				?>
				<h3>Category</h3>
				<li><a href="<?php echo get_category_link( $interlink_category );?>"><?php echo $term->name;?></a></li>
				<?php
				*/
				do_action('category-recent-posts', $term->term_id);
			}
		} else if ( is_single() ) {
			$category = get_the_category();
			$cat_id = $category[0]->term_id;
			$interlink_page = get_option( $cat_id . "_interlink_page" );
			 
			$interlink_category = get_post_meta( $interlink_page, "interlink_category", TRUE );
			if ($interlink_category) {
                            $term = get_term( $interlink_category, 'category' );
				do_action('home-interlink-page',$term->term_id);
				
				/*
				?>
				<h3>Category</h3>
				<li><a href="<?php echo get_category_link( $interlink_category );?>"><?php echo $term->name;?></a></li>
				<?php
				*/
				do_action('category-recent-posts', $term->term_id);
                               
			}
		}
	}
	
	function update( $new_instance, $old_instance ) {
		return $new_instance;
	}
	
	//function form( $instance ) {
		
	//}
	
} 
function register_interlinks_widget() {  
    register_widget( 'InterLinks_Widget' );  
}  
add_action( 'widgets_init', 'register_interlinks_widget' );


function display_home_interlnk_page_link($page=''){
   // echo $page;
   	
	$interlinks_settings = get_option("interlinks_settings", TRUE);
	$title_heading = explode("|", $interlinks_settings['title_heading']);?>
      <aside id="recent-posts-5" class="widget widget_recent_entries">		
	<?php
//	if ( !is_home() && !is_front_page() ){
		?>
		<?php echo $title_heading[0];?><?php echo $interlinks_settings['home_title'];?><?php echo $title_heading[1];?>
		<?php
	//}
	
	// get all pages which are assigned to categories
	$args = array(
		"post_type" => "page",
		"meta_key" => "interlink_category",
		"meta_value" => "1",
		"meta_compare" => ">"
	);
	
	query_posts($args);
        
	?>
         
	<?php //echo $title_heading[0];?><?php //echo $interlinks_settings['pages_title'];?><?php //echo $title_heading[1];?>
	<ul>
           <?php
            if(( $page!='page' && $page!='home' && !isset($interlinks_settings['dont_show_home']))  || $page=='page' ||  $page=='home' || get_the_ID()==get_option('page_on_front') ){ ?>
            <li><a href='<?php echo home_url();?>'><?php if(isset($interlinks_settings['pages_title']) && $interlinks_settings['pages_title']!='' ) echo $interlinks_settings['pages_title']; else echo 'Home';?></a></li>
	<?php } ?>
                
                <?php
        if ($page=='home' ){
          
	while ( have_posts() ){
		the_post();
                if(get_the_ID()!=get_option('page_on_front')) {
		?>
		<li><a href="<?php the_permalink();?>"><?php the_title();?></a><br/></li>
		<?php
	}
        }
        }
       else if ($page=='page' ) 
        {
          
           global $post;
            $title = get_the_title($post); 
     //   echo get_option('page_on_front');
             if(get_the_ID()!=get_option('page_on_front') ) {
           ?>
       
           <li><a href="<?php echo get_permalink();?>"><?php  echo $title;?></a><br/></li>
       <?php    
        
        }
        }
        else  {
            global $post; 
			$interlink_category = get_post_meta($post->ID, "interlink_category", TRUE);
                        $term = get_term( $interlink_category, 'category' );
                    //   echo  $interlink_category;
            $args = array(
		"post_type" => "page",
		"meta_key" => "interlink_category",
		"meta_value" => $page,
		"meta_compare" => "="
	);
	
	query_posts($args);
            while ( have_posts() ){
		the_post();
                if(get_the_ID()!=get_option('page_on_front') || isset($interlinks_settings['dont_show_home'])) {
		?>
		<li><a href="<?php the_permalink();?>"><?php the_title();?></a><br/></li>
		<?php
	}
            }
            
          
        }
        
        
	?>
	</ul>
          </aside>
	<?php
	wp_reset_query();
}
add_action("home-interlink-page", "display_home_interlnk_page_link");

function display_category_recent_posts($cat_id){
  
	// get all posts of category
	$interlinks_settings = get_option("interlinks_settings", TRUE);
	$title_heading = explode("|", $interlinks_settings['title_heading']);
	$args = array(
		"post_type" => "post",
		'cat' => $cat_id,
		"posts_per_page" => $interlinks_settings["number_of_recent_posts"],
              //  'orderby'=>'rand'
	);
	
        query_posts($args);
	?>
           <aside id="recent-posts-5" class="widget widget_recent_entries">		
	<?php echo $title_heading[0];?><?php echo $interlinks_settings['posts_title'];?><?php echo $title_heading[1];?>
	<ul>
	<?php
	while ( have_posts() ){
		the_post();
		?>
		<li><a href="<?php the_permalink();?>"><?php the_title();?></a><br/></li>
		<?php
	}
	?>
	</ul>
          	</aside>
	<?php
	wp_reset_query();
}
add_action("category-recent-posts", "display_category_recent_posts", 10, 2);

function display_interlink_related_posts($content) {
if (is_single()) {
	global $post;
	$current_post = $post->ID;
        $interlinks_settings = get_option("interlinks_settings", TRUE);
        $title_heading = explode("|", $interlinks_settings['title_heading']);
	if(isset($interlinks_settings["number_of_related_posts"]))
        $nopost=$interlinks_settings["number_of_related_posts"];
        else
        $nopost=5;
                
	
$content .='
<style>
    .my-recent-posts ul li {float:left; padding: 2%; width: 20%;height: 70px; list-style-type: none; list-style-position: inside;list-style:none;
    padding-left:0; margin: 0;}
</style>
<div class="my-recent-posts">';
    
  if(isset($interlinks_settings['related_title']) && $interlinks_settings['related_title']!='') { 
 $content .=$title_heading[0].$interlinks_settings['related_title'].$title_heading[1];
    } 
        
     $content .="<ul>";
	
        $i=0;
        	$categories = get_the_category();
foreach ($categories as $category) :
	$posts = get_posts('numberposts='.$nopost.'&category='. $category->term_id . '&exclude=' . $current_post.'&orderby=rand');
foreach($posts as $post) :
    $i++;
	
 $content .='<li><a href="'.get_permalink().'">'.get_the_title().'</a></li>';
	if($i==$nopost) break; endforeach; ?><?php  if($i==$nopost) break; 
        
        endforeach;
 $content .='</ul>
</div>';
	
        
		}
               /* if (is_page()) {
	global $post;
	$current_post = $post->ID;
        $interlinks_settings = get_option("interlinks_settings", TRUE);
	$title_heading = explode("|", $interlinks_settings['title_heading']);
	$interlink_category = get_post_meta($post->ID, "interlink_category", TRUE);
	if ($interlink_category) {
	$term = get_term( $interlink_category, 'category' );

	?>
<style>
    .my-recent-posts ul li {float:left; padding: 2%; width: 20%; height: 70px; list-style-type: none;list-style-position: inside;list-style:none;
    padding-left:0;margin: 0;}
</style>
<div class="my-recent-posts">
    <?php if(isset($interlinks_settings['related_title']) && $interlinks_settings['related_title']!='') { ?>
    <?php echo $title_heading[0];?><?php echo $interlinks_settings['related_title']; ?><?php echo $title_heading[1];?>
    <?php } ?>
    
    <ul>
	<?php
                 if(isset($interlinks_settings["number_of_related_posts"]))
                    $nopost=$interlinks_settings["number_of_related_posts"];
                    else
                 $nopost=5;
                    
                    $nopost=2;
                    
	$posts = get_posts('numberposts='.$nopost.'&category='.  $term->term_id . '&exclude=' . $current_post);
foreach($posts as $post) :
	?>
<li><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></li>
	<?php endforeach; ?>
</ul>
</div>
	<?php
		} }*/
             
	wp_reset_query();
           return $content;
        
}
add_action('the_content', 'display_interlink_related_posts');
